#include "stm32f103.h"
#include "main.h"
#include "usart.h"

void Delay_Ms(unsigned int uiCount)  //ǾȷʱԼ1MS
{ 
  
  unsigned int i,j;

  for( j=0;j<uiCount;j++ )
  {  
    for( i=0;i<0x2AFF;i++ )
    {
      ;
    }
  }
} 

void Delay_Us(unsigned int uiCount)  //ǾȷʱԼ1US
{ 
  
  unsigned int i,j;

  for( j=0;j<uiCount;j++ )
  {  
    for( i=0;i<5;i++ )
    {
      ;
    }
  }
} 

void RCC_HSE_ON(void)
{  
     RCC_CR = 0x83; //λ RCC_CR 
	 RCC_CR |= 0x00010000;  //HSE
     while(((RCC_CR & 0x00020000) >> 16)==1);  //ȴⲿHSEȶ
	 FLASH_ACR = 0x2; //2ʵȴ״̬
	 FLASH_ACR |= 0x10; //Ԥȡʹ
	 RCC_CFGR = 0x0; //RESET RCC_CFGR Register
	 RCC_CFGR |= 0x001D0000; //HSEƵΪPLL룬PLL 9Ƶ 
	 RCC_CR |=  0x01000000; //PLL
     while(((RCC_CR & 0x01000000) >> 25)==1); //ȴPLLƵʱȶ
     RCC_CFGR |= 0x00000400; //APB1 2Ƶ
	 RCC_CFGR |= 0x2; //PLLʱΪϵͳʱ
     while(((RCC_CFGR & 0x00000008) >> 4)==1); //ȴPLLƵʱȶ
}

//GPIOBʼ
void GPIOB_Init(void)
{
	GPIOB_CRL &= 0xFFFFFFF0; // GPIOA_0-4Ϊģʽ
    GPIOB_CRL |= 0x3; 
	GPIOB_ODR |= 0x1;
}

main()
{
    RCC_HSE_ON();
	RCC_APB2ENR=0xFFFFFFFF;
	
	GPIOB_Init();
	USART1_Init();
 	while(1)
 	{
    	GPIOB_ODR &= 0xFFFFFFF0;
		Delay_Ms(500);
		USART1_Send_Byte(0x55);
     	GPIOB_ODR |= 0x1;
		Delay_Ms(500); 
		USART1_Send_Byte(0xCC);
 	}
}
