#include "stm32f103.h"
#include "USART.h"

void USART1_Init(void)
{
	RCC_APB2ENR |= 0x00004000;  //UART1RCCʱ
    USART1_CR1 = 0x0; //Reset USART1
	USART1_CR1 |= 0x0C;  //ʹ UART1_ 
    USART1_CR2 = 0;
	USART1_CR3 = 0;
	USART1_BRR = 0x0; //Reset 
	USART1_BRR |=  0x0271; //òرʼĴΪ115200  	
	//GPIO  
    RCC_APB2ENR|=0x0C;	// APB2 ʱʹܼĴ ʹGPI0Aʱ	
	GPIOA_CRH &= 0xFFFFFF00F; //RESET PIN 9 10 
	GPIOA_CRH |= 0x4B0; //GPIOA9AFPP 10 
    USART1_CR1 |= 0x2000; //Enable UART1

}

void USART1_Send_Byte(unsigned char ucSend_Data)
{
    USART1_DR = ucSend_Data & 0x01FF;
	while(((USART1_SR & 0x80) >> 7)!=1); //ȴTXEΪ1 
}

unsigned char USART1_Receive_Byte(void)
{
    unsigned char ucTemp = 0;
	
	while(((USART1_SR & 0x20) >> 5)!=1); //ȴRXNEΪ1,ûнյ 	
	//while(USART1_SR == 0xC0);

	ucTemp = USART1_DR;
	//USART1_Send_Byte(ucTemp);
	
	return ucTemp;	
}

void USART1_Send_String(unsigned char *pucString)
{
   while(*pucString!='\0')
   {
       USART1_Send_Byte(*pucString);
	   pucString++;
   }
}
